#pragma semicolon 1

#include <sourcemod>
#include "calcplayerscore"

// Global Definitions
#define PLUGIN_VERSION "1.1.1"

new ScoreMod[MAXPLAYERS+1] = {0, ...};
new Score[MAXPLAYERS+1] = {-1, ...};

// Functions
public Plugin:myinfo =
{
	name = "ScoreMod",
	author = "bl4nk",
	description = "Modify player's scores",
	version = PLUGIN_VERSION,
	url = "http://forums.alliedmods.net"
};

public OnPluginStart()
{
	LoadTranslations("common.phrases");
	RegAdminCmd("sm_addscore", Command_AddScore, ADMFLAG_CHEATS, "sm_addscore <#userid|name> <points>");
	RegAdminCmd("sm_setscore", Command_SetScore, ADMFLAG_CHEATS, "sm_setscore <#userid|name> <score>");
	RegAdminCmd("sm_setscoremod", Command_SetScoreMod, ADMFLAG_CHEATS, "sm_setscoremod <#userid|name> <score>");
}

public OnMapEnd()
{
	ResetScores();
}

public bool:OnClientConnect(client)
{
	ResetScores(client);
	return true;
}

public OnCalcPlayerScore(client, score)
{
	if (Score[client] > -1)
	{
		return Score[client];
	}

	return score + ScoreMod[client];
}

public Action:Command_AddScore(client, args)
{
	if (args < 2)
	{
		ReplyToCommand(client, "[SM] Usage: sm_addscore <#userid|name> <points>");
		return Plugin_Handled;
	}

	decl String:arg[65];
	GetCmdArg(1, arg, sizeof(arg));

	decl String:target_name[MAX_TARGET_LENGTH];
	decl target_list[MAXPLAYERS], target_count, bool:tn_is_ml;

	if ((target_count = ProcessTargetString(
			arg,
			client,
			target_list,
			MAXPLAYERS,
			COMMAND_FILTER_CONNECTED,
			target_name,
			sizeof(target_name),
			tn_is_ml)) <= 0)
	{
		ReplyToTargetError(client, target_count);
		return Plugin_Handled;
	}

	decl String:arg2[8];
	GetCmdArg(2, arg2, sizeof(arg2));

	new score = StringToInt(arg2);

	for (new i = 0; i < target_count; i++)
	{
		ScoreMod[target_list[i]] += score;
	}

	return Plugin_Handled;
}

public Action:Command_SetScore(client, args)
{
	if (args < 2)
	{
		ReplyToCommand(client, "[SM] Usage: sm_setscore <#userid|name> <score>");
		return Plugin_Handled;
	}

	decl String:arg[65];
	GetCmdArg(1, arg, sizeof(arg));

	decl String:target_name[MAX_TARGET_LENGTH];
	decl target_list[MAXPLAYERS], target_count, bool:tn_is_ml;

	if ((target_count = ProcessTargetString(
			arg,
			client,
			target_list,
			MAXPLAYERS,
			COMMAND_FILTER_CONNECTED,
			target_name,
			sizeof(target_name),
			tn_is_ml)) <= 0)
	{
		ReplyToTargetError(client, target_count);
		return Plugin_Handled;
	}

	decl String:arg2[8];
	GetCmdArg(2, arg2, sizeof(arg2));

	new score = StringToInt(arg2);

	for (new i = 0; i < target_count; i++)
	{
		Score[target_list[i]] = score;
	}

	return Plugin_Handled;
}

public Action:Command_SetScoreMod(client, args)
{
	if (args < 2)
	{
		ReplyToCommand(client, "sm_setscoremod <#userid|name> <score>");
		return Plugin_Handled;
	}

	decl String:arg[65];
	GetCmdArg(1, arg, sizeof(arg));

	decl String:target_name[MAX_TARGET_LENGTH];
	decl target_list[MAXPLAYERS], target_count, bool:tn_is_ml;

	if ((target_count = ProcessTargetString(
			arg,
			client,
			target_list,
			MAXPLAYERS,
			COMMAND_FILTER_ALIVE,
			target_name,
			sizeof(target_name),
			tn_is_ml)) <= 0)
	{
		ReplyToTargetError(client, target_count);
		return Plugin_Handled;
	}

	decl String:arg2[8];
	GetCmdArg(2, arg2, sizeof(arg2));

	new score = StringToInt(arg2);

	for (new i = 0; i < target_count; i++)
	{
		ScoreMod[target_list[i]] = score;
	}

	return Plugin_Handled;
}

ResetScores(client=0)
{
	if (!client)
	{
		for (new i = 1; i <= MAXPLAYERS; i++)
		{
			ScoreMod[i] = 0;
			Score[i] = -1;
		}
	}
	else
	{
		ScoreMod[client] = 0;
		Score[client] = -1;
	}
}